<script lang="ts">
import Vue from 'vue';
import { IsMobileMixin } from '../../../mixins';
import VideoModal from '../video-modal.vue';
import { UseLocalizedVideoSubtitles } from '~/mixins';

export default Vue.extend({
  name: 'ByIndustrySolutionsBlock',
  components: { VideoModal },
  mixins: [IsMobileMixin, UseLocalizedVideoSubtitles],
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
  },
  data() {
    return {
      PageProgress: 8,
      modalIsOpen: false,
      currentVideoUrl: '',
    };
  },
  computed: {
    applyPercent() {
      return this.PageProgress;
    },
  },
  mounted() {
    const solutionsContainer = this.$refs.solutionsBlockParent.$el;
    window.addEventListener('scroll', this.updatePageProgress);
    window.addEventListener('load', () => {
      const { children } = solutionsContainer;

      const observer = new IntersectionObserver(
        (entries) => {
          entries.forEach((entry) => {
            entry.target.classList.toggle(
              'scroll-solutions__active-section',
              entry.isIntersecting,
            );
            entry.target.setAttribute(
              'aria-disabled',
              entry.target.ariaDisabled ? 'true' : 'false',
            );
          });
        },
        {
          threshold: this.isMobile ? 0.2 : 0.4,
          rootMargin: '-120px',
        },
      );

      for (let i = 0; i < children?.length; i++) {
        observer.observe(children[i]);
      }
    });
  },
  destroyed() {
    window.removeEventListener('scroll', this.updatePageProgress);
  },
  methods: {
    getElementDistance(elem) {
      let location = 0;
      if (elem.offsetParent) {
        do {
          location += elem.offsetTop;

          elem = elem.offsetParent;
        } while (elem);
      }
      return location >= 0 ? location : 0;
    },

    updatePageProgress() {
      const elem = this.$refs.scrollSolutions;

      // above line makes it so that you can only have this component once per page
      const elementDistanceFromTop = this.getElementDistance(elem);
      const currentPosition = window.pageYOffset;
      const elementHeight = elem.clientHeight;

      if (
        elementDistanceFromTop < currentPosition + 120 && // 120px is the height of the navigation
        currentPosition < elementDistanceFromTop + elementHeight
      ) {
        const percent =
          ((currentPosition - elementDistanceFromTop) / elementHeight) * 100 +
          15;
        if (percent > 100) {
          this.PageProgress = 100;
        } else {
          this.PageProgress = percent;
        }
      }
    },
    handleLearnMoreClick(url) {
      if (
        url.toLowerCase().includes('youtube') ||
        url.toLowerCase().includes('vimeo')
      ) {
        this.modalIsOpen = true;
        this.currentVideoUrl = url;
      } else {
        window.location.href = url;
      }
    },
    closeModal() {
      this.modalIsOpen = false;
      this.currentVideoUrl = '';
    },
  },
});
</script>

<template>
  <div
    class="solutions-block"
    :class="{ 'solutions-block--white-bg': data.white_bg }"
  >
    <SlpContainer>
      <div :id="data.id" class="test solutions-block__container">
        <SlpRow>
          <SlpColumn :cols="8">
            <SlpTypography
              tag="h2"
              variant="heading2-bold"
              :class="
                data.sub_description ? 'slp-mb-16' : ' slp-mb-64 slp-mb-md-96'
              "
              >{{ data.subtitle }}
            </SlpTypography>

            <SlpTypography
              v-if="data.sub_description"
              tag="p"
              variant="body1"
              class="slp-mb-96"
              >{{ data.sub_description }}
            </SlpTypography>
          </SlpColumn>
        </SlpRow>
        <div ref="scrollSolutions" class="scroll-solutions">
          <SlpColumn :cols="1">
            <div class="progress-container">
              <div
                class="progress-bar"
                :style="{ height: `${PageProgress}%` }"
              ></div>
            </div>
          </SlpColumn>
          <SlpColumn
            ref="solutionsBlockParent"
            :cols="5"
            class="scroll-solutions__col slp-align-items-center"
          >
            <div
              v-for="(solution, index) in data.solutions"
              :id="index"
              :key="index"
              class="scroll-solutions__info"
            >
              <SlpIcon
                v-if="solution.icon"
                :name="solution.icon.name"
                :alt="solution.icon.alt"
                :variant="solution.icon.variant"
                size="md"
              />
              <SlpTypography tag="h3" variant="heading3-bold" class="slp-my-8"
                >{{ solution.title }}
              </SlpTypography>
              <div
                class="description"
                v-html="
                  data.markdown
                    ? $md.render(solution.description)
                    : solution.description
                "
              />
              <ul v-if="solution?.list">
                <li
                  v-for="item in solution.list"
                  :key="item"
                  class="scroll-solutions__list-item"
                >
                  <SlpIcon
                    class="slp-mr-8 scroll-solutions__list-icon"
                    variant="product"
                    name="check"
                    slp-color="accent-400"
                  />
                  <div v-html="$md.render(item)" />
                </li>
              </ul>
              <SlpButton
                v-if="solution.link_text"
                variant="tertiary"
                class="slp-mt-32 cta-button"
                :aria-label="solution.data_ga_name"
                :data-ga-name="solution.data_ga_name"
                :data-ga-location="solution.data_ga_location"
                @click.native="handleLearnMoreClick(solution?.link_url)"
                >{{ solution.link_text }}
                <SlpIcon name="chevron-lg-right" variant="product" />
              </SlpButton>
            </div>
          </SlpColumn>
          <SlpColumn :cols="4" class="scroll-solutions__img-col">
            <img
              v-if="data.sub_image"
              class="scroll-solutions__img"
              :src="data.sub_image"
              :alt="data.alt"
              loading="lazy"
            />
          </SlpColumn>
        </div>
      </div>
    </SlpContainer>
    <VideoModal
      v-show="modalIsOpen"
      light-background
      :visible="modalIsOpen"
      @close="modalIsOpen = false"
    >
      <template #body>
        <!-- Use Embed video url -->
        <iframe
          ref="video"
          :src="createVideoSource(currentVideoUrl)"
          title="Video player"
          allow="accelerometer; clipboard-write; encrypted-media; gyroscope; picture-in-picture"
          allowfullscreen
        ></iframe> </template
    ></VideoModal>
  </div>
</template>

<style scoped lang="scss">
.solutions-block {
  .description {
    &:deep(p) {
      margin-top: $spacing-24;
    }
    &:deep(ul) {
      padding-left: 32px;
      margin-top: 24px;
      li {
        margin-bottom: 24px;
        position: relative;

        &:before {
          content: url('/nuxt-images/icons/list-check.svg');
          position: absolute;
          top: 0;
          left: -30px;
        }
      }
    }
  }
  .cta-button {
    padding-left: 0;
  }
  background: $color-surface-800;
  position: relative;
  padding: 96px 0 160px 0;

  @media (max-width: $breakpoint-md) {
    padding: $spacing-48 0;
  }

  &__container {
    @media (max-width: $breakpoint-md) {
      padding: 0 $spacing-16 $spacing-96;
    }
  }

  &--white-bg {
    background: none;
  }

  .scroll-solutions__img {
    max-width: 100%;
  }
}

.scroll-solutions {
  display: flex;
  flex-wrap: wrap;
  position: relative;
  transition: opacity 0.2s;

  &__col div {
    padding-right: $spacing-16;
  }

  &__info:not(:last-child) {
    padding-bottom: $spacing-96;

    @media (max-width: $breakpoint-md) {
      padding-bottom: $spacing-64;
      height: auto;
    }
  }

  &__info {
    opacity: 0.6;
    transition: opacity 0.2s;
    word-break: break-word;

    @media (max-width: $breakpoint-md) {
      padding: 0 $spacing-16 0 $spacing-64;
    }

    img {
      max-width: $spacing-32;
    }

    h3 {
      word-break: break-word;
    }
  }

  &__img-col {
    img {
      position: sticky;
      top: 160px;
    }

    @media (max-width: $breakpoint-md) {
      display: none;
    }
  }

  &__list-item {
    display: flex;
    margin: $spacing-24 0;
    align-items: flex-start;
  }

  &__list-icon {
    line-height: 1.8;
  }
}

.scroll-solutions__active-section {
  opacity: 1;
}

.progress-container {
  width: 2px;
  background: $color-surface-200;
  position: absolute;
  top: 0;
  bottom: 0;
  left: 0;
}

.progress-bar {
  position: absolute;
  background: $color-surface-700;
  width: 2px;
}

.solutions-block__header {
  margin: $spacing-96 auto;

  img {
    width: 100%;
  }

  h2,
  p {
    width: 380px;
  }

  p {
    float: right;
  }

  .solutions-block__text-container {
    width: 100%;
  }
}

.slp-btn {
  color: $color-text-300;
}

.slp-text-button,
.slp-btn-ghost {
  font-weight: 600;
  padding-left: 0;
}

.slp-btn .slp-icon,
.solutions-block__link .slp-icon {
  vertical-align: middle;
  margin-left: $spacing-4;
}
</style>
